<?php

/**
 * Banner Section
 *
 * @package bike_workshop
 */

$wp_customize->add_section(
	'bike_workshop_banner_section',
	array(
		'panel'    => 'bike_workshop_front_page_options',
		'title'    => esc_html__( 'Banner Section', 'bike-workshop' ),
		'priority' => 10,
	)
);

// Banner Section - Enable Section.
$wp_customize->add_setting(
	'bike_workshop_enable_banner_section',
	array(
		'default'           => false,
		'sanitize_callback' => 'bike_workshop_sanitize_switch',
	)
);

$wp_customize->add_control(
	new Bike_Workshop_Toggle_Switch_Custom_Control(
		$wp_customize,
		'bike_workshop_enable_banner_section',
		array(
			'label'    => esc_html__( 'Enable Banner Section', 'bike-workshop' ),
			'section'  => 'bike_workshop_banner_section',
			'settings' => 'bike_workshop_enable_banner_section',
		)
	)
);

 $wp_customize->add_setting( 'bike_workshop_banner_heading', array(
    'default'           => '',
    'transport'         => 'refresh',
    'sanitize_callback' => 'sanitize_text_field',
) );

// Add the control for the new heading
$wp_customize->add_control( 'bike_workshop_banner_heading', array(
    'label'    => __( 'Banner Heading', 'bike-workshop' ),
    'section'  => 'bike_workshop_banner_section',
    'settings' => 'bike_workshop_banner_heading',
    'type'     => 'text',
	'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
) );

if ( isset( $wp_customize->selective_refresh ) ) {
	$wp_customize->selective_refresh->add_partial(
		'bike_workshop_enable_banner_section',
		array(
			'selector' => '#bike_workshop_banner_section .section-link',
			'settings' => 'bike_workshop_enable_banner_section',
		)
	);
}

// Banner Section - Banner Slider Content Type.
$wp_customize->add_setting(
	'bike_workshop_banner_slider_content_type',
	array(
		'default'           => 'post',
		'sanitize_callback' => 'bike_workshop_sanitize_select',
	)
);

$wp_customize->add_control(
	'bike_workshop_banner_slider_content_type',
	array(
		'label'           => esc_html__( 'Select Banner Slider Content Type', 'bike-workshop' ),
		'section'         => 'bike_workshop_banner_section',
		'settings'        => 'bike_workshop_banner_slider_content_type',
		'type'            => 'select',
		'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
		'choices'         => array(
			'page' => esc_html__( 'Page', 'bike-workshop' ),
			'post' => esc_html__( 'Post', 'bike-workshop' ),
		),
	)
);

// Banner Slider Category Setting.
$wp_customize->add_setting('bike_workshop_banner_slider_category', array(
	'default'           => 'slider',
	'sanitize_callback' => 'sanitize_text_field',
));

// Add custom control for Banner Slider Category with conditional visibility.
$wp_customize->add_control(new Bike_Workshop_Customize_Category_Dropdown_Control($wp_customize, 'bike_workshop_banner_slider_category', array(
	'label'    => __('Select Banner Category', 'bike-workshop'),
	'section'  => 'bike_workshop_banner_section',
	'settings' => 'bike_workshop_banner_slider_category',
	'active_callback' => function() use ($wp_customize) {
		return $wp_customize->get_setting('bike_workshop_banner_slider_content_type')->value() === 'post';
	},
)));


for ( $bike_workshop_i = 1; $bike_workshop_i <= 3; $bike_workshop_i++ ) {

	// Banner Section - Select Banner Post.
	$wp_customize->add_setting(
		'bike_workshop_banner_slider_content_post_' . $bike_workshop_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'bike_workshop_banner_slider_content_post_' . $bike_workshop_i,
		array(
			/* translators: %d: Post Count. */
			'label'           => sprintf( esc_html__( 'Select Post %d', 'bike-workshop' ), $bike_workshop_i ),
			'description'     => sprintf( esc_html__( 'Kindly :- Select a Post based on the category selected in the upper settings', 'bike-workshop' ), $bike_workshop_i ),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_banner_slider_content_post_' . $bike_workshop_i,
			'active_callback' => 'bike_workshop_is_banner_slider_section_and_content_type_post_enabled',
			'type'            => 'select',
			'choices'         => bike_workshop_get_post_choices(),
		)
	);

	// Banner Section - Select Banner Page.
	$wp_customize->add_setting(
		'bike_workshop_banner_slider_content_page_' . $bike_workshop_i,
		array(
			'sanitize_callback' => 'absint',
		)
	);

	$wp_customize->add_control(
		'bike_workshop_banner_slider_content_page_' . $bike_workshop_i,
		array(
			/* translators: %d: Page Count. */
			'label'           => sprintf( esc_html__( 'Select Page %d', 'bike-workshop' ), $bike_workshop_i ),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_banner_slider_content_page_' . $bike_workshop_i,
			'active_callback' => 'bike_workshop_is_banner_slider_section_and_content_type_page_enabled',
			'type'            => 'select',
			'choices'         => bike_workshop_get_page_choices(),
		)
	);

	// Banner Section - Button Label.
	$wp_customize->add_setting(
		'bike_workshop_banner_button_label_' . $bike_workshop_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'sanitize_text_field',
		)
	);

	$wp_customize->add_control(
		'bike_workshop_banner_button_label_' . $bike_workshop_i,
		array(
			/* translators: %d: Button Label Count. */
			'label'           => sprintf( esc_html__( 'Button Label %d', 'bike-workshop' ), $bike_workshop_i ),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_banner_button_label_' . $bike_workshop_i,
			'type'            => 'text',
			'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
		)
	);

	// Banner Section - Button Link.
	$wp_customize->add_setting(
		'bike_workshop_banner_button_link_' . $bike_workshop_i,
		array(
			'default'           => '',
			'sanitize_callback' => 'esc_url_raw',
		)
	);

	$wp_customize->add_control(
		'bike_workshop_banner_button_link_' . $bike_workshop_i,
		array(
			/* translators: %d: Button Link Count. */
			'label'           => sprintf( esc_html__( 'Button Link %d', 'bike-workshop' ), $bike_workshop_i ),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_banner_button_link_' . $bike_workshop_i,
			'type'            => 'url',
			'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
		)
	);
}


// Slider Button Label Color
$wp_customize->add_setting('bike_workshop_slider_btn_color',array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'bike_workshop_slider_btn_color',array(
			'label'           => __('Banner Button Label Color', 'bike-workshop'),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_slider_btn_color',
			'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
		)
	)
);
// Slider Button Background Color
$wp_customize->add_setting('bike_workshop_slider_btn_bg_color',array(
		'default'           => '',
		'sanitize_callback' => 'sanitize_hex_color',
	)
);
$wp_customize->add_control(new WP_Customize_Color_Control($wp_customize,'bike_workshop_slider_btn_bg_color',array(
			'label'           => __('Banner Button Background Color', 'bike-workshop'),
			'section'         => 'bike_workshop_banner_section',
			'settings'        => 'bike_workshop_slider_btn_bg_color',
			'active_callback' => 'bike_workshop_is_banner_slider_section_enabled',
		)
	)
);


$wp_customize->add_setting( 
	'bike_workshop_banner_settings_upgraded_features',
	array(
		'sanitize_callback' => 'sanitize_text_field'
	)
);

$wp_customize->add_control(
	'bike_workshop_banner_settings_upgraded_features', 
	array(
		'type'=> 'hidden',
		'description' => "
			<div class='customizer-upgraded-features'>
				<i class='fas fa-info-circle'></i>
				<span class='pro-text'>
					Unlock Premium <strong>Features</strong> ?<br>
					<a target='_blank' href='". esc_url(BIKE_WORKSHOP_PREMIUM_PAGE) ." '>Upgrade Pro</a>
				</div>
			</div>
		",
		'section' => 'bike_workshop_banner_section'
	)
);